



/*****************************************************************************
 *  Self-defined function declaration section					 			*
 ****************************************************************************/

/*	
 *	Description:
 *		Compare if drive letter and physical location is matched
 *
 *	Input:		
 *		<szAntecedentResult> : strings of disk numbers return from WMI calls
 *		<szDependentResult> : strings of drive letters return from WMI calls
 *		<szDiskNumber> : disk number of a volume. Ex. "Disk #0"
 *		<szDriveLetter> : drive letter of a volume. Ex. "D:\"
 *		
 *
 *	Output:
 *		None
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
BOOL split_disk_number_and_drive_letter(TCHAR* szAntecedentResult,TCHAR *szDependentResult,TCHAR *szDiskNumber,TCHAR *szDriveLetter);

/*	
 *	Description:
 *		Return Physical name according to disk number 
 *
 *	Input:		
 *		<szAnteDiskDriveToDiskPart> : strings of physical name to be compared
 *		<szDepDiskDriveToDiskPart> : strings of disk number to be compared
 *
 *	Output:
 *		<szPhysicalNmae> : Physical disk name 
 *		<szDiskNumber> : Disk number 
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
BOOL split_disk_physical_name_and_disk_number(TCHAR* szAnteDiskDriveToDiskPart,TCHAR *szDepDiskDriveToDiskPart,TCHAR *szPhysicalNmae,TCHAR *szDiskNumber);

/*	
 *	Description:
 *		Return Physical name according to disk number 
 *
 *	Input:		
 *		<szDeviceIDDiskDrive> : strings of physical name to be compared
 *		<szSCSITargetIDDiskDrive> : strings of disk number to be compared
 *
 *	Output:
 *		<szPhysicalNmae> : Physical disk name 
 *		<scsiID> : slot id
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
BOOL split_disk_physical_name(TCHAR* szDeviceIDDiskDrive,TCHAR *szPhysicalNmae);