

/*****************************************************************************
 *  Define	section												 			*
 ****************************************************************************/
//#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows. 

/*****************************************************************************
 *  Include	section												 			*
 ****************************************************************************/
//#include "stdafx.h"
#include <stdio.h>
#include <windows.h>
#include <setupapi.h>
#include <devguid.h>
#include <regstr.h>
#include <TCHAR.h>
#include <WinIoctl.h>
#include "wmi_function.h"
#include "string_function.h"


/*****************************************************************************
 *  Self-defined function body	section							 			*
 ****************************************************************************/

/*	
 *	Description:
 *		Compare if drive letter and physical location is matched
 *
 *	Input:		
 *		<szName> : request name of wmi
 *
 *	Output:
 *		<szResult> : result of wmi strings
 *		<numOfResult> : number of string return
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
int wmi_get_value_by_name(char *szClassName,WCHAR *szPropertyName,BOOL bISInteger,vector<List> &szResult,int *numOfResult)
{
	List list;
	HRESULT hres;
	//char *szClassName = "Win32_LogicalDiskToPartition";
	char strClassName[128];

	sprintf(strClassName,"SELECT * FROM %s",szClassName);
	printf("strClassName = %s\n",strClassName);

    // Step 1: --------------------------------------------------
    // Initialize COM. ------------------------------------------

    hres =  CoInitializeEx(0, COINIT_MULTITHREADED); 
    if (FAILED(hres))
    {
        cout << "Failed to initialize COM library. Error code = 0x" 
            << hex << hres << endl;
        return 1;                  // Program has failed.
    }

    // Step 2: --------------------------------------------------
    // Set general COM security levels --------------------------
    // Note: If you are using Windows 2000, you need to specify -
    // the default authentication credentials for a user by using
    // a SOLE_AUTHENTICATION_LIST structure in the pAuthList ----
    // parameter of CoInitializeSecurity ------------------------

    hres =  CoInitializeSecurity(
        NULL, 
        -1,                          // COM authentication
        NULL,                        // Authentication services
        NULL,                        // Reserved
        RPC_C_AUTHN_LEVEL_DEFAULT,   // Default authentication 
        RPC_C_IMP_LEVEL_IMPERSONATE, // Default Impersonation  
        NULL,                        // Authentication info
        EOAC_NONE,                   // Additional capabilities 
        NULL                         // Reserved
        );

                      
    if (FAILED(hres))
    {
        cout << "Failed to initialize security. Error code = 0x" 
            << hex << hres << endl;
        CoUninitialize();
        return 1;                    // Program has failed.
    }
    
    // Step 3: ---------------------------------------------------
    // Obtain the initial locator to WMI -------------------------

    IWbemLocator *pLoc = NULL;

    hres = CoCreateInstance(
        CLSID_WbemLocator,             
        0, 
        CLSCTX_INPROC_SERVER, 
        IID_IWbemLocator, (LPVOID *) &pLoc);
 
    if (FAILED(hres))
    {
        cout << "Failed to create IWbemLocator object."
            << " Err code = 0x"
            << hex << hres << endl;
        CoUninitialize();
        return 1;                 // Program has failed.
    }

    // Step 4: -----------------------------------------------------
    // Connect to WMI through the IWbemLocator::ConnectServer method

    IWbemServices *pSvc = NULL;
	
    // Connect to the root\cimv2 namespace with
    // the current user and obtain pointer pSvc
    // to make IWbemServices calls.
    hres = pLoc->ConnectServer(
         _bstr_t(L"ROOT\\CIMV2"), // Object path of WMI namespace
         NULL,                    // User name. NULL = current user
         NULL,                    // User password. NULL = current
         0,                       // Locale. NULL indicates current
         NULL,                    // Security flags.
         0,                       // Authority (e.g. Kerberos)
         0,                       // Context object 
         &pSvc                    // pointer to IWbemServices proxy
         );
    
    if (FAILED(hres))
    {
        cout << "Could not connect. Error code = 0x" 
             << hex << hres << endl;
        pLoc->Release();     
        CoUninitialize();
        return 1;                // Program has failed.
    }

    //cout << "Connected to ROOT\\CIMV2 WMI namespace" << endl;


    // Step 5: --------------------------------------------------
    // Set security levels on the proxy -------------------------

    hres = CoSetProxyBlanket(
       pSvc,                        // Indicates the proxy to set
       RPC_C_AUTHN_WINNT,           // RPC_C_AUTHN_xxx
       RPC_C_AUTHZ_NONE,            // RPC_C_AUTHZ_xxx
       NULL,                        // Server principal name 
       RPC_C_AUTHN_LEVEL_CALL,      // RPC_C_AUTHN_LEVEL_xxx 
       RPC_C_IMP_LEVEL_IMPERSONATE, // RPC_C_IMP_LEVEL_xxx
       NULL,                        // client identity
       EOAC_NONE                    // proxy capabilities 
    );

    if (FAILED(hres))
    {
        cout << "Could not set proxy blanket. Error code = 0x" 
            << hex << hres << endl;
        pSvc->Release();
        pLoc->Release();     
        CoUninitialize();
        return 1;               // Program has failed.
    }

    // Step 6: --------------------------------------------------
    // Use the IWbemServices pointer to make requests of WMI ----

    // For example, get the name of the operating system
    IEnumWbemClassObject* pEnumerator = NULL;
    hres = pSvc->ExecQuery(
        bstr_t("WQL"), 
        //bstr_t("SELECT * FROM Win32_OperatingSystem"),
		//bstr_t("SELECT * FROM Win32_LogicalDiskToPartition"),
		bstr_t(strClassName),
        WBEM_FLAG_FORWARD_ONLY,//WBEM_FLAG_FORWARD_ONLY | WBEM_FLAG_RETURN_IMMEDIATELY, 
        NULL,
        &pEnumerator);
    
    if (FAILED(hres))
    {
        cout << "Query for operating system name failed."
            << " Error code = 0x" 
            << hex << hres << endl;
        pSvc->Release();
        pLoc->Release();
        CoUninitialize();
        return 1;               // Program has failed.
    }

    // Step 7: -------------------------------------------------
    // Get the data from the query in step 6 -------------------
 
    IWbemClassObject *pclsObj;
    ULONG uReturn = 0;
	 int i = 0;
   
    while (pEnumerator)
    {
        HRESULT hr = pEnumerator->Next(WBEM_INFINITE, 1, 
            &pclsObj, &uReturn);

        if(0 == uReturn)
        {
			break;
        }

        VARIANT vtPropAntecedent;

        // Get the value of the Name property
        //hr = pclsObj->Get(L"Antecedent", 0, &vtPropAntecedent, 0, 0);
		 hr = pclsObj->Get(szPropertyName, 0, &vtPropAntecedent, 0, 0);
		 //wcout << " Antecedent1 : " << vtPropAntecedent.ulVal << endl;
        //wcout << " Antecedent : " << vtPropAntecedent.bstrVal << endl;
		        
		if(bISInteger)
		{
			list.no = vtPropAntecedent.ulVal;
			szResult.push_back(list);
		}
		else
		{
		
			// Convert BSTR to char * string
			char* lpszTextAntecedent = _com_util::ConvertBSTRToString(vtPropAntecedent.bstrVal); 
			//printf("lpszTextAntecedent = %s(len = %d)\n",lpszTextAntecedent,strlen(lpszTextAntecedent));

			char szTextAntecedent[256]; //BUGBUG:add the following three line of code to prevent szResult.push_back error
			memset(szTextAntecedent,0,sizeof(szTextAntecedent));
			memcpy(szTextAntecedent,lpszTextAntecedent,strlen(lpszTextAntecedent));
			memset(list.name,0,sizeof(list.name));
			memcpy(list.name,szTextAntecedent,strlen(szTextAntecedent));// 2012-02-22
					
			//printf("list.name = %s\n",list.name);
			
			szResult.push_back(list);
		}

		// Clear Variant
		//=======
		VariantClear(&vtPropAntecedent);
       pclsObj->Release();
		i++;
    }

	memcpy(numOfResult,&i,sizeof(i));

    // Cleanup
    // ========
    
    pSvc->Release();
	pLoc->Release();
	
    pEnumerator->Release();
	//pclsObj->Release();
	
	CoUninitialize();
	
	return 0;

}

/*	
 *	Description:
 *		Get PNPDeviceID of specified drive
 *
 *	Input:		
 *		<szRawDriveLetter> : drive letter of a volume. Ex. "D:\"
 *
 *	Output:
 *		<szPNPDeviceID> : drive letter of a volume. Ex. "0 or 2..."
 *
 *	Return:
 *		0 indicates found matehed PNPDeviceID
 *		1 indicates no matched drive letter
 *		2 indicates no matched physical name
 *		3 indicates no matched PNPDeviceID
 */
int WMIGetPNPDeviceID(TCHAR *szRawDriveLetter,TCHAR *szPNPDeviceID)
{
	int		nRet = 0;

	BOOL	bCompareResult = TRUE;
	BOOL	bFoundMatched = FALSE;

	TCHAR	strCurrDiskNumber[32];
	TCHAR	strCurrPhysicalName[32];
	TCHAR	strRawDriveLetter[32] ;
	TCHAR	strRawDiskNumber[32];

	int		nScsiBusNumber = 0;

	// Paramters for Win32_LogicalDiskToPartition
	vector<List> szAntetLogicDiskToPartition;
	vector<List> szDepeLogicDiskToPartition;
	vector<List>::iterator iterAntetLogicDiskToPart;
	vector<List>::iterator iterDepLogicDiskToPart;

	// Step 1: -------------------------------------------------- 
	// Get WMI Values of Win32_LogicalDiskToPartition

	/* Get LogicDiskToPartition information*/
	WMIGetLogicDiskToPartitionInfo(szAntetLogicDiskToPartition,szDepeLogicDiskToPartition);
	iterAntetLogicDiskToPart = szAntetLogicDiskToPartition.begin();
	iterDepLogicDiskToPart = szDepeLogicDiskToPartition.begin();
   for(; iterAntetLogicDiskToPart != szAntetLogicDiskToPartition.end(),iterDepLogicDiskToPart != szDepeLogicDiskToPartition.end(); ++iterAntetLogicDiskToPart,++iterDepLogicDiskToPart)
   {
	   //printf("szAntecedentLogicalDiskToPartition : Name = %s\n",iterAntetLogicDiskToPart->name);
	   //printf("szDependentLogicalDiskToPartition : Name = %s\n",iterDepLogicDiskToPart->name);
	   /* Split strings to get disk number and drive letter */
	   	memset(strRawDiskNumber,0,sizeof(strRawDiskNumber));
		memset(strRawDriveLetter,0,sizeof(strRawDriveLetter));
		split_disk_number_and_drive_letter(iterAntetLogicDiskToPart->name,iterDepLogicDiskToPart->name,strRawDiskNumber,strRawDriveLetter);
		printf("split_disk_number_and_drive_letter : strRawDiskNumber = %s\n",strRawDiskNumber);
		printf("split_disk_number_and_drive_letter : strRawDriveLetter = %s\n",strRawDriveLetter);

		/* Compare drive letter and than get disk number */
		//if(strcmp(strCurrDriveLetter,strRawDriveLetter)==0) //BUGBUG: should use szDriveLetter
		if(strcmp(szRawDriveLetter,strRawDriveLetter)==0)
		{
			printf("letter matched\n");
			strcpy(strCurrDiskNumber,strRawDiskNumber);
			//printf("strCurrDiskNumber= %s\n",strCurrDiskNumber);
			bFoundMatched = TRUE;
			break;
		}
		else
		{
			printf("letter not matched\n");
			bFoundMatched = FALSE;
		}
	
   }
   if(bFoundMatched == FALSE)
   {
		printf("No Matched drive letter\n");
		nRet = WMI_NO_MATCHED_DRIVE_LETTER;
	   return nRet;
   }
   printf("\n");

    /* Parameters for Win32DiskDriveToDiskPartition */
   	vector<List> szAnteDiskDriveToDiskPart;
	vector<List> szDepDiskDriveToDiskPart;
	vector<List>::iterator iterAnteDiskDriveToDiskPart; 
	vector<List>::iterator iterDepDiskDriveToDiskPart; 
	TCHAR strPhysicalName[32];
	TCHAR strDiskNumber[32];

	memset(strPhysicalName,0,sizeof(strPhysicalName));
	memset(strDiskNumber,0,sizeof(strDiskNumber));

	// Step 2: -------------------------------------------------- 
	// Get WMI Values of Win32DiskDriveToDiskPartition

	/* Get DiskDriveToDiskPartition information*/
	WMIGetDiskDriveToDiskPartitionInfo(szAnteDiskDriveToDiskPart,szDepDiskDriveToDiskPart);
	iterAnteDiskDriveToDiskPart = szAnteDiskDriveToDiskPart.begin();
	iterDepDiskDriveToDiskPart = szDepDiskDriveToDiskPart.begin();

	for(; iterAnteDiskDriveToDiskPart != szAnteDiskDriveToDiskPart.end(),iterDepDiskDriveToDiskPart != szDepDiskDriveToDiskPart.end(); ++iterAnteDiskDriveToDiskPart,++iterDepDiskDriveToDiskPart)
   {
	  //printf("szAntecedentDiskDriveToDiskPartition : Name = %s\n",iterAnteDiskDriveToDiskPart->name);
	  //printf("szDependentDiskDriveToDiskPartition : Name = %s\n",iterDepDiskDriveToDiskPart->name);

	  // Split strings into physical device name and disk number
	  split_disk_physical_name_and_disk_number(iterAnteDiskDriveToDiskPart->name,iterDepDiskDriveToDiskPart->name,strPhysicalName,strDiskNumber);
	  printf("strPhysicalName = %s\n",strPhysicalName);
	  printf("strDiskNumber = %s\n",strDiskNumber);

	  // Compare get disk number and than get physical name
	  if(strcmp(strCurrDiskNumber,strDiskNumber)==0)
		{
			printf("disk number matched\n");
			strcpy(strCurrPhysicalName,strPhysicalName);
			//printf("strCurrPhysicalName= %s\n",strCurrPhysicalName);
			bFoundMatched = TRUE;
			break;
		}
		else
		{
			printf("disk number not matched\n");
			bFoundMatched = FALSE;
		}
		
   }
	
	if(bFoundMatched == FALSE)
   {
		printf("No Matched physical name");
		nRet = WMI_NO_MATCHED_PHYSICAL_NAME;
	   return nRet;
   }
	printf("\n");

	/*  Parameters for Win32DiskDriveToDiskPartition */
   	vector<List> szDeviceIDDiskDrive;
	vector<List> szPNPDeviceIDDiskDrive;//vector<List> szSCSITargetIDDiskDrive;
	vector<List>::iterator iterDeviceIDDiskDrive; 
	vector<List>::iterator iterPNPDeviceIDDiskDrive; //vector<List>::iterator iterSCSITargetIDDiskDrive; 

	TCHAR strPhysicalName_DiskDrive[32];
	int	  nScsiBus = 0;

	szDeviceIDDiskDrive.empty();
	memset(strPhysicalName_DiskDrive,0,sizeof(strPhysicalName_DiskDrive));
	// Step 3: -------------------------------------------------- 
   // Get WMI Values of Win32DiskDrive

	/* Get disk drive information*/
	WMIGetDiskDriveInfo(szDeviceIDDiskDrive,szPNPDeviceIDDiskDrive);

	/* find matched physical name*/
	iterDeviceIDDiskDrive = szDeviceIDDiskDrive.begin();
	iterPNPDeviceIDDiskDrive = szPNPDeviceIDDiskDrive.begin();

	for(; iterDeviceIDDiskDrive != szDeviceIDDiskDrive.end(),iterPNPDeviceIDDiskDrive != szPNPDeviceIDDiskDrive.end(); ++iterDeviceIDDiskDrive,++iterPNPDeviceIDDiskDrive)
   {
	  //printf("szDeviceIDDiskDrive : Name = %s\n",iterDeviceIDDiskDrive->name);
	  //printf("szSCSITargetIDDiskDrive : no = %d\n",iterSCSITargetIDDiskDrive->no);

	  /*  Split strings into physical device name and scsi id(slot number) */
	  split_disk_physical_name(iterDeviceIDDiskDrive->name,strPhysicalName_DiskDrive);
	  printf("strPhysicalName_DiskDrive = %s\n",strPhysicalName_DiskDrive);
	  
	 
		/* Compare physical name and than get scsi number */
		if(strstr(strCurrPhysicalName,strPhysicalName_DiskDrive)!=NULL)
		{
			printf("physical name matched\n");

			/* Get PNPDeviceID */
			memcpy(szPNPDeviceID,iterPNPDeviceIDDiskDrive->name,strlen(iterPNPDeviceIDDiskDrive->name));
			//printf("szDeviceIDDiskDrive : Name = %s\n",iterPNPDeviceIDDiskDrive->name);
			bFoundMatched = TRUE;
			break;
		}
		else
		{
			printf("physical name not matched\n");
			bFoundMatched = FALSE;
		}
	}	

	if(bFoundMatched == FALSE)
   {
		printf("No Matched physical name");
		nRet = WMI_NO_MATCHED_PNPDEVICEID;
	   return nRet;
   }
	else
	{
		nRet = WMI_FOUND_PNPDEVICEID;
	}


	return nRet;
}

BOOL WMIGetSCSIBusNumber(TCHAR *szDriveLetter,int *nSCSIBusNumber)
{
	BOOL bCompareResult = TRUE;

	TCHAR	strCurrDriveLetter[32] = "C:";
	TCHAR	strCurrDiskNumber[32];
	TCHAR	strCurrPhysicalName[32];
	int		nScsiBusNumber = 0;
	TCHAR	strRawDriveLetter[32] ;
	TCHAR	strRawDiskNumber[32];

	/* Paramters for Win32_LogicalDiskToPartition */
	vector<List> szAntetLogicDiskToPartition;
	vector<List> szDepeLogicDiskToPartition;
	vector<List>::iterator iterAntetLogicDiskToPart;
	vector<List>::iterator iterDepLogicDiskToPart;

	// Step 1: -------------------------------------------------- 
	// Get WMI Values of Win32_LogicalDiskToPartition
	WMIGetLogicDiskToPartitionInfo(szAntetLogicDiskToPartition,szDepeLogicDiskToPartition);
	iterAntetLogicDiskToPart = szAntetLogicDiskToPartition.begin();
	iterDepLogicDiskToPart = szDepeLogicDiskToPartition.begin();
   for(; iterAntetLogicDiskToPart != szAntetLogicDiskToPartition.end(),iterDepLogicDiskToPart != szDepeLogicDiskToPartition.end(); ++iterAntetLogicDiskToPart,++iterDepLogicDiskToPart)
   {
	   //printf("szAntecedentLogicalDiskToPartition : Name = %s\n",iterAntetLogicDiskToPart->name);
	   //printf("szDependentLogicalDiskToPartition : Name = %s\n",iterDepLogicDiskToPart->name);
	   // Split strings to get disk number and drive letter
	   	memset(strRawDiskNumber,0,sizeof(strRawDiskNumber));
		memset(strRawDriveLetter,0,sizeof(strRawDriveLetter));
		split_disk_number_and_drive_letter(iterAntetLogicDiskToPart->name,iterDepLogicDiskToPart->name,strRawDiskNumber,strRawDriveLetter);
		printf("split_disk_number_and_drive_letter : strRawDiskNumber = %s\n",strRawDiskNumber);
		printf("split_disk_number_and_drive_letter : strRawDriveLetter = %s\n",strRawDriveLetter);

		// Compare drive letter and than get disk number
		if(strcmp(strCurrDriveLetter,strRawDriveLetter)==0)
		{
			printf("letter matched\n");
			strcpy(strCurrDiskNumber,strRawDiskNumber);
			printf("strCurrDiskNumber= %s\n",strCurrDiskNumber);
		}
		else
		{
			printf("letter not matched\n");
		}
		//break;
   }
   printf("\n");

    /* Parameters for Win32DiskDriveToDiskPartition */
   	vector<List> szAnteDiskDriveToDiskPart;
	vector<List> szDepDiskDriveToDiskPart;
	vector<List>::iterator iterAnteDiskDriveToDiskPart; 
	vector<List>::iterator iterDepDiskDriveToDiskPart; 
	TCHAR strPhysicalName[32];
	TCHAR strDiskNumber[32];

	memset(strPhysicalName,0,sizeof(strPhysicalName));
	memset(strDiskNumber,0,sizeof(strDiskNumber));

	// Step 2: -------------------------------------------------- 
	// Get WMI Values of Win32DiskDriveToDiskPartition
	WMIGetDiskDriveToDiskPartitionInfo(szAnteDiskDriveToDiskPart,szDepDiskDriveToDiskPart);
	iterAnteDiskDriveToDiskPart = szAnteDiskDriveToDiskPart.begin();
	iterDepDiskDriveToDiskPart = szDepDiskDriveToDiskPart.begin();
	for(; iterAnteDiskDriveToDiskPart != szAnteDiskDriveToDiskPart.end(),iterDepDiskDriveToDiskPart != szDepDiskDriveToDiskPart.end(); ++iterAnteDiskDriveToDiskPart,++iterDepDiskDriveToDiskPart)
   {
	  //printf("szAntecedentDiskDriveToDiskPartition : Name = %s\n",iterAnteDiskDriveToDiskPart->name);
	  //printf("szDependentDiskDriveToDiskPartition : Name = %s\n",iterDepDiskDriveToDiskPart->name);

	  /* Split strings into physical device name and disk number */
	  split_disk_physical_name_and_disk_number(iterAnteDiskDriveToDiskPart->name,iterDepDiskDriveToDiskPart->name,strPhysicalName,strDiskNumber);
	  printf("strPhysicalName = %s\n",strPhysicalName);
	  printf("strDiskNumber = %s\n",strDiskNumber);

	  // Compare get disk number and than get physical name
	  if(strcmp(strCurrDiskNumber,strDiskNumber)==0)
		{
			printf("disk number matched\n");
			strcpy(strCurrPhysicalName,strPhysicalName);
			printf("strCurrPhysicalName= %s\n",strCurrPhysicalName);
		}
		else
		{
			printf("disk number not matched\n");
		}
		//break;
   }

	printf("\n");

	// Parameters for Win32DiskDriveToDiskPartition
   	vector<List> szDeviceIDDiskDrive;
	vector<List> szSCSITargetIDDiskDrive;
	vector<List>::iterator iterDeviceIDDiskDrive; 
	vector<List>::iterator iterSCSITargetIDDiskDrive; 

	TCHAR strPhysicalName_DiskDrive[32];
	int	  nScsiBus = 0;

	szDeviceIDDiskDrive.empty();
	memset(strPhysicalName_DiskDrive,0,sizeof(strPhysicalName_DiskDrive));
	// Step 3: -------------------------------------------------- 
   // Get WMI Values of Win32DiskDrive
	WMIGetDiskDriveInfo(szDeviceIDDiskDrive,szSCSITargetIDDiskDrive);
	iterDeviceIDDiskDrive = szDeviceIDDiskDrive.begin();
	iterSCSITargetIDDiskDrive = szSCSITargetIDDiskDrive.begin();

	for(; iterDeviceIDDiskDrive != szDeviceIDDiskDrive.end(),iterSCSITargetIDDiskDrive != szSCSITargetIDDiskDrive.end(); ++iterDeviceIDDiskDrive,++iterSCSITargetIDDiskDrive)
   {
	  //printf("szDeviceIDDiskDrive : Name = %s\n",iterDeviceIDDiskDrive->name);
	  //printf("szSCSITargetIDDiskDrive : no = %d\n",iterSCSITargetIDDiskDrive->no);

	  // Split strings into physical device name and scsi id(slot number)
	  split_disk_physical_name(iterDeviceIDDiskDrive->name,strPhysicalName_DiskDrive);
	  printf("strPhysicalName_DiskDrive = %s\n",strPhysicalName_DiskDrive);

	  // Get SCSI ID
	  nScsiBus = iterSCSITargetIDDiskDrive->no;
	  printf("nScsiBus = %d\n",nScsiBus);


	  // Compare physical name and than get scsi number
		if(strstr(strCurrPhysicalName,strPhysicalName_DiskDrive)!=NULL)
		{
			printf("physical name matched\n");
			nScsiBusNumber = nScsiBus;
			printf("nScsiBusNumber= %d\n",nScsiBusNumber);
		}
		else
		{
			printf("physical name not matched\n");
		}
		//break;
   }	

	return TRUE;
}

BOOL WMIGetLogicDiskToPartitionInfo(vector<List> &szAntecedentLogicalDiskToPartition,vector<List> &szDependentLogicalDiskToPartition)
{
	char *szClassLogicalDiskToPartition = "Win32_LogicalDiskToPartition";
	WCHAR *szNameAntecedent = L"Antecedent";
	WCHAR *szNameDependent = L"Dependent";
	int numOfAntecedentResult = 0;
	int numOfDependentResult = 0;
	//vector<List> szAntecedentLogicalDiskToPartition;
	//vector<List> szDependentLogicalDiskToPartition;

	// Step 1: -------------------------------------------------- 
	printf("Get WMI Values of Win32_LogicalDiskToPartition\n==================================\n");
   // Get WMI Values of Win32_LogicalDiskToPartition
	
	//Get Antecedent of Win32_LogicalDiskToPartition
	wmi_get_value_by_name(szClassLogicalDiskToPartition,szNameAntecedent,FALSE,szAntecedentLogicalDiskToPartition,&numOfAntecedentResult);
#if 0
	printf("numOfAntecedentResult = %d\n",numOfAntecedentResult);
	vector<List>::iterator iterAntecedent = szAntecedentLogicalDiskToPartition.begin();
   for(; iterAntecedent != szAntecedentLogicalDiskToPartition.end(); ++iterAntecedent)
   {
	   printf("szAntecedentLogicalDiskToPartition : Name = %s\n",iterAntecedent->name);
	    // Split strings to get disk number and drive letter
   }
#endif

   //Get Dependent of Win32_LogicalDiskToPartition
   wmi_get_value_by_name(szClassLogicalDiskToPartition,szNameDependent,FALSE,szDependentLogicalDiskToPartition,&numOfDependentResult);
#if 0 
	printf("numOfDependentResult = %d\n",numOfDependentResult);
	vector<List>::iterator iterDependent = szDependentLogicalDiskToPartition.begin();
   for(; iterDependent != szDependentLogicalDiskToPartition.end(); ++iterDependent)
   {
	   printf("szDependentLogicalDiskToPartition : Name = %s\n",iterDependent->name);
   }
#endif

   printf("\n");
	return TRUE;
}

BOOL WMIGetDiskDriveToDiskPartitionInfo(vector<List> &szAnteDiskDriveToDiskPart,vector<List> &szDepDiskDriveToDiskPart)
{
	
	WCHAR *szNameAntecedent = L"Antecedent";
	WCHAR *szNameDependent = L"Dependent";
	int numOfAntecedentResult = 0;
	int numOfDependentResult = 0;
	
	char *szClassDiskDriveToDiskPartition = "Win32_DiskDriveToDiskPartition";
	
	// Step 2: -------------------------------------------------- 
   // Get WMI Values of Win32DiskDriveToDiskPartition
   printf("Get WMI Values of Win32_DiskDriveToDiskPartition\n==================================\n");
  
   //Get Antecedent of Win32_DiskToPartition
   wmi_get_value_by_name(szClassDiskDriveToDiskPartition,szNameAntecedent,FALSE,szAnteDiskDriveToDiskPart,&numOfAntecedentResult);
#if 0
   iterAnteDiskDriveToDiskPart = szAnteDiskDriveToDiskPart.begin();
   for(; iterAnteDiskDriveToDiskPart != szAnteDiskDriveToDiskPart.end(); ++iterAnteDiskDriveToDiskPart)
   {
	   printf("szAntecedentDiskDriveToDiskPartition : Name = %s\n",iterAnteDiskDriveToDiskPart->name);
   }
#endif

    //Get Dependent of Win32_DiskDriveToDiskPartition
   wmi_get_value_by_name(szClassDiskDriveToDiskPartition,szNameDependent,FALSE,szDepDiskDriveToDiskPart,&numOfDependentResult);
#if 0
	printf("numOfDependentResult = %d\n",numOfDependentResult);
	iterDepDiskDriveToDiskPart = szDepDiskDriveToDiskPart.begin();
   for(; iterDepDiskDriveToDiskPart != szDepDiskDriveToDiskPart.end(); ++iterDepDiskDriveToDiskPart)
   {
	   printf("szDependentDiskDriveToDiskPartition : Name = %s\n",iterDepDiskDriveToDiskPart->name);
   }
#endif
   return TRUE;
}

BOOL WMIGetDiskDriveInfo(vector<List> &szDeviceIDDiskDrive,vector<List> &szPNPDeviceID)
{
	int numOfAntecedentResult = 0;
	int numOfDependentResult = 0;

	// Step 3: -------------------------------------------------- 
   // Get WMI Values of Win32DiskDrive
   printf("Get WMI Values of Win32_DiskDrive\n==================================\n");
   char *szClassDiskDrive = "Win32_DiskDrive";
   WCHAR *szNameDeviceName = L"Name";
	WCHAR *szNamePNPDeviceID = L"PNPDeviceID";;//L"SCSITargetID";
   //vector<List> szDeviceIDDiskDrive;
   //vector<List> szSCSITargetIDDiskDrive;

   //Get Disk name of Win32_DiskDrive
   wmi_get_value_by_name(szClassDiskDrive,szNameDeviceName,FALSE,szDeviceIDDiskDrive,&numOfAntecedentResult);
#if 0
   iterAntecedent = szDeviceIDDiskDrive.begin();
   for(; iterAntecedent != szDeviceIDDiskDrive.end(); ++iterAntecedent)
   {
	   printf("szAntecedentDiskDrive : Name = %s\n",iterAntecedent->name);
   }
#endif
	
   //Get SCSITargetID of Win32_DiskDrive
   
   wmi_get_value_by_name(szClassDiskDrive,szNamePNPDeviceID,FALSE,szPNPDeviceID,&numOfDependentResult);
#if 0
	printf("numOfDependentResult = %d\n",numOfDependentResult);
	
	vector<List>::iterator iterPNPDeviceID = szPNPDeviceID.begin();
   for(; iterPNPDeviceID != szPNPDeviceID.end(); ++iterPNPDeviceID)
   {
	   printf("szDependentDiskDrive : szPNPDeviceID = %s\n",iterPNPDeviceID->name);
   }
#endif
   return TRUE;
}